<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- vcs-module.qdoc -->
  <title>vcs QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">vcs QML Type</h1>
<span class="subtitle"></span>
<!-- $$$vcs-brief -->
<p>Provides support for version control systems. <a href="#details">More...</a></p>
<!-- @@@vcs -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsModules .</td></tr><tr><td class="memItemLeft rightAlign topAlign"> Since:</td><td class="memItemRight bottomAlign"> Qbs 1.10</td></tr></table></div><ul>
<li><a href="qml-qbsmodules-vcs-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbsmodules-vcs.html#headerFileName-prop">headerFileName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-vcs.html#repoDir-prop">repoDir</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-vcs.html#repoState-prop">repoState</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-vcs.html#toolFilePath-prop">toolFilePath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-vcs.html#type-prop">type</a></b></b> : string</li>
</ul>
<!-- $$$vcs-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>The <code>vcs</code> module provides the current state of the project's repository via the <a href="qml-qbsmodules-vcs.html#repoState-prop">repoState</a> property. By default, a <code>C</code> header is also generated, allowing for simple retrieval of the repository state directly from within your C/C++ sources. This is useful to embed information into binaries about the exact state of the repository from which they were built.</p>
<p>For example:</p>
<pre class="cpp">

  <span class="preprocessor">#include &lt;vcs-repo-state.h&gt;</span>
  <span class="preprocessor">#include &lt;iostream&gt;</span>

  <span class="type">int</span> main()
  {
      std<span class="operator">::</span>cout <span class="operator">&lt;</span><span class="operator">&lt;</span> <span class="string">&quot;I was built from &quot;</span> <span class="operator">&lt;</span><span class="operator">&lt;</span> VCS_REPO_STATE <span class="operator">&lt;</span><span class="operator">&lt;</span> std<span class="operator">::</span>endl;
  }

</pre>
<p>Above, a header file called <code>vcs-repo-state.h</code> is created, defining a macro called <code>VCS_REPO_STATE</code>, which expands to a character constant describing the current state of the repository. For Git, this would be the current HEAD's commit hash.</p>
<!-- @@@vcs -->
<h2>Property Documentation</h2>
<!-- $$$headerFileName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="headerFileName-prop">
<td class="tblQmlPropNode"><p>
<span class="name">headerFileName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The name of the C header file to be created.</p>
<p>Set this to <code>undefined</code> if you do not want a header file to be generated.</p>
<p>Default: <code>&quot;vcs-repo-state.h&quot;</code></p>
</div></div><!-- @@@headerFileName -->
<br/>
<!-- $$$repoDir -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="repoDir-prop">
<td class="tblQmlPropNode"><p>
<span class="name">repoDir</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The root directory of the repository.</p>
<p>Default: The top-level project directory (<a href="qml-qbslanguageitems-project.html#sourceDirectory-prop">project.sourceDirectory</a>).</p>
</div></div><!-- @@@repoDir -->
<br/>
<!-- $$$repoState -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="repoState-prop">
<td class="tblQmlPropNode"><p>
<span class="name">repoState</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The current state of the repository.</p>
<p>For example, in Git this is the commit hash of the current HEAD.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@repoState -->
<br/>
<!-- $$$toolFilePath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="toolFilePath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">toolFilePath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Set this property if the tool has an unusual name in your local installation, or if it is located in a directory that is not in the build environment's <code>PATH</code>.</p>
<p>Default: The file name of the version control tool corresponding to <a href="qml-qbsmodules-vcs.html#type-prop">type</a>.</p>
</div></div><!-- @@@toolFilePath -->
<br/>
<!-- $$$type -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="type-prop">
<td class="tblQmlPropNode"><p>
<span class="name">type</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The version control system used in the project.</p>
<p>Currently, the supported values are <code>&quot;git&quot;</code> and <code>&quot;svn&quot;</code>.</p>
<p>Default: auto-detected</p>
</div></div><!-- @@@type -->
<br/>
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
